'MMEDIT!!! Basic Version = CMM2
'MMEDIT!!! Port = COM7:115200:10,300
'MMEDIT!!! Device = CMM2
'MMEDIT!!! Config = 1001111011200100100200000100010
  ' TassyJim Jun2020
  ' PS2 mouse and joystick to serial interface demo
  ' Arduino sends 4 bytes
  ' Button states - byte,X movement - signed byte,Y movement - signed byte, Wheel movement- signed byte
  ' the first byte is also used to determine which device is sending data
  
  DIM INTEGER mouseX, mouseY, mouseW, mouseB, mouseR, mouseL, mouseM          ' mouse position and buttons
  DIM INTEGER mouseMove, mouseClick, joyAMove, joyAClick, joyBMove, joyBClick ' flags to indicate changes

  dim integer joyAX, joyAY, joyAB, joyAB1, joyAB2, joyBX, joyBY, joyBB, joyBB1, joyBB2
  
  OPEN "com1: 19200,256,mousetrap,4" AS #2 ' 19200 is the fastest that all Maximite/micromites can handle
  initM
  
  DO
    IF INKEY$ = " " THEN initM ' might be needed if the mouse interface is interrupted.
    
    IF mouseMove = 1 or mouseClick = 1 THEN
      mouseL = mouseB AND 1
      mouseR = (mouseB AND 2)/2     ' extract the individual button states
      mouseM = (mouseB AND 4)/4
      IF mouseX < 0 THEN mouseX = 0 ' keep the pointer on the screen
      IF mouseY < 0 THEN mouseY = 0
      IF mouseX >= MM.HRES THEN mouseX = MM.HRES -1
      IF mouseY >= MM.VRES THEN mouseY = MM.VRES -1
      TEXT 10,30, "Mouse "+STR$(mouseX,6,0)+STR$(mouseY,6,0)+STR$(mouseW,3,0)+STR$(mouseL,2,0)+STR$(mouseM,2,0)+STR$(mouseR,2,0)
      mouseClick = 0
      mouseMove = 0
    ENDIF
    
    if joyAMove = 1 or joyAClick = 1 then
      joyAB1 = joyAB and 1
      joyAB2 = (joyAB and 2)/2
      TEXT 10,50, "Joy A "+STR$(joyAX,6,0)+STR$(joyAY,6,0)+"   "+STR$(joyAB1,2,0)+STR$(joyAB2,2,0)
      joyAMove = 0
      joyAClick = 0
    endif
    
    if joyBMove = 1 or joyBClick = 1 then
      joyBB1 = joyBB and 1
      joyBB2 = (joyBB and 2)/2
      TEXT 10,70, "Joy B "+STR$(joyBX,6,0)+STR$(joyBY,6,0)+"   "+STR$(joyBB1,2,0)+STR$(joyBB2,2,0)
      joyBMove = 0
      joyBClick = 0
    endif
    
  LOOP
  
  CLOSE #2
  
SUB initM
  LOCAL j$
  j$ = INPUT$(255,#2) ' flush the serial buffer
  mouseX = MM.HRES/2
  mouseY = MM.VRES/2
  CLS
  text 10,10,"Device     X     Y  Z 1 2 3"
END SUB
  
SUB mousetrap
  LOCAL INTEGER deltaB, deltaX, deltaY, DELTAw, device
  deltaB = ASC(INPUT$(1,#2))  ' read 4 bytes
  deltaX = ASC(INPUT$(1,#2))
  deltaY = ASC(INPUT$(1,#2))
  deltaW = ASC(INPUT$(1,#2))
  device = deltaB \ 64        'top 2 bits determine device sending data
  IF device = 0 THEN                                  ' its a mouse
    deltaB = deltaB AND 7
    IF deltaX > 127 THEN deltaX = deltaX - 256        ' signed 8 bit integers
    IF deltaY > 127 THEN deltaY = deltaY - 256
    IF deltaW > 127 THEN deltaW = deltaW - 256
    IF mouseB <> deltaB THEN                          '  buttons have changed
      mouseClick = 1                                  ' set the flag
      mouseB = deltaB                                 ' remember button states
    ENDIF
    IF deltaX <>0 OR deltaY <> 0 or deltaW <> 0 THEN  ' mouse has moved
      mouseMove = 1                                   ' set the flag
      mouseX = mouseX + deltaX
      mouseY = mouseY - deltaY
      mouseW = deltaW
    ENDIF
    
  ELSEIF device = 1 THEN                          ' its joystick A
    deltaX = deltaX + (deltaB AND &B00110000)*16  ' add high bits
    deltaY = deltaY + (deltaB AND &B00001100)*64
    deltaB = deltaB AND 3
    IF joyAB <> deltaB THEN                       '  buttons have changed
      joyAClick = 1                               ' set the flag
      joyAB = deltaB                              ' remember button states
    ENDIF
    if joyAX <> deltaX or joyAY <> deltaY then    ' joystick A has moved
      joyAMove = 1
      joyAX = deltaX
      joyAY = deltaY
    endif
    
  ELSEIF device = 2 THEN                          ' its joystick B
    deltaX = deltaX + (deltaB AND &B00110000)*16  ' add high bits
    deltaY = deltaY + (deltaB AND &B00001100)*64
    deltaB = deltaB AND 3
    IF joyBB <> deltaB THEN                       '  buttons have changed
      joyBClick = 1                               ' set the flag
      joyBB = deltaB                              ' remember button states
    ENDIF
    if joyBX <> deltaX or joyAY <> deltaY then    ' joystick A has moved
      joyBMove = 1
      joyBX = deltaX
      joyBY = deltaY
    endif
  ENDIF
END SUB
